﻿/// <reference path="../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../rubbish.ts"/>

function PgSubscribeToLog(input) {
    var $logContainer = $('#' + input.containerId + ' .live-output');

    var pauseAutoScroll = false;
    var animating = false;

    $logContainer.scroll(function () {
        if (!animating)
            pauseAutoScroll = true;

        if (this.scrollTop + $(this).innerHeight() >= this.scrollHeight)
            pauseAutoScroll = false;
    });

    var autoScroll = function () {
        if (!pauseAutoScroll) {
            animating = true;
            $logContainer[0].scrollTop = $logContainer[0].scrollHeight;
            animating = false;
        }
    };

    var logDataReceived = function (data) {
        var formatEntry = function (entry) {
            var logClass;

            if (entry.l < 10)
                logClass = 'debug';
            else if (entry.l < 20)
                logClass = 'info';
            else if (entry.l < 30)
                logClass = 'warning';
            else
                logClass = 'error';

            var $entry = $('<span></span>');
            $entry.addClass(logClass);
            $entry.text(entry.m);
            return $entry;
        };

        for (var i = 0; i < data.length; i++)
            $logContainer.append(formatEntry(data[i]));

        autoScroll();

        setTimeout(function () {
            $.ajax({
                type: 'POST',
                url: input.updateUrl,
                data: { id: input.id },
                success: logDataReceived
            });
        }, input.interval);
    };

    $.ajax({
        type: 'POST',
        url: input.updateUrl,
        data: { id: input.id },
        success: logDataReceived
    });
}
